/*                              DB/C 9.1                        */
/*                      DB/C Interface to SQL                   */
/*              (c) Copyright  1997  Subject, Wills & Company   */

#if 0
/*** tlib * release 9.1 version %v %f * */
/* release 9.1 version 4 17-Oct-97,09:06:22 */

/*** CHANGE HISTORY ***/
/* 1 DBCSQL.C 10-Jun-96,17:15:40,`JSF' Release 9.1 copied from release 9.0   */
/* 2 DBCSQL.C 01-Aug-97,15:22:14,`JSF' export functions and fix bug that     */
/*      could cause a gpf                                                    */
/* 3 DBCSQL.C 17-Oct-97,06:54:00,`JSF' added version 9.0 changes             */
/* 4 DBCSQL.C 17-Oct-97,09:06:22,`JSF' fixed compiler warnings               */
/*** CHANGE HISTORY ***/
#endif

#if defined(WIN32) | defined(WIN16)
#include <windows.h>
#endif
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#if defined(WIN32) | defined(WIN16)
#define stricmp(a, b) _stricmp(a, b)
#endif

#ifdef OS2
#define SQLOS2
#endif

#define INC_UTIL
#define INC_TARGET
#include "dbcsql.h"

static char cmdbuf[CMDSIZE];
static char cnctstr[CMDSIZE];
static char cursorname[20];
static char uid[50];
static char passwd[50];
static char server[50];
static char string[50];
static char errorstr[50];
static int connectflag;
static int localerr;
static int foundcursor;

#ifdef __STDC__
long dbcsqlx(unsigned char *, unsigned char **, unsigned char **);
char *dbcsqlm(long);
void dbcsqlc(void);
#else
long dbcsqlx();
char *dbcsqlm();
void dbcsqlc();
#endif


#ifdef WIN16
#pragma off(unreferenced)
BOOL FAR PASCAL LibMain(HINSTANCE hinst, WORD wDataSeg, WORD cbHeapSize, LPSTR lpszCmdLine)
#pragma on(unreferenced)
{
	clearglobal();
	return 1;
}
#endif

/* DBCSQLX */
long dbcsqlx(adr1, adr2, adr3)
unsigned char *adr1;
unsigned char **adr2;
unsigned char **adr3;
{
	int retcode;
	int cursornum;
	int cmdlen;
	int fcmdmatch;
	char *ptr1, *ptr2, *ptr3, *destptr;
	int index;
	int fetchtype;
	int scroll;
	int lock;
	int optstart;
	int optend;

	localerr = FALSE;
	errorstr[0] = 0;

	/* convert command line to ascii string */
	if (dbctostr(adr1, cmdbuf, CMDSIZE) == -1) {
		strcpy(errorstr, "[DB/C]: Could not build command string: 1");
		return(-1);
	}

	strncpy(cnctstr, cmdbuf, 50);
	ptr1 = strtok(cnctstr, " \t");
	if (ptr1 == NULL) {
		localerr = TRUE;
		strcpy(errorstr, "[DB/C]: Could not build command string: 2");
		return(-1);
	}

	cmdlen = 0;
	while (ptr1[cmdlen]) {
		ptr1[cmdlen] = (char)toupper(ptr1[cmdlen]);
		cmdlen++;
	}


	/* replace parameters */
	if (buildsql(cmdbuf, (unsigned char **)adr2) < 0) {
		localerr = TRUE;
		strcpy(errorstr, "[DB/C]: Could not build command string: 3");
		return(-1);
	}


	/* Pull cursor name out of cmdbuf */
	foundcursor = getcursorname(cmdbuf, cursorname);
	cursornum = getcursornum(cursorname);
	if (cursornum < 0) {
		localerr = TRUE;
		strcpy(errorstr, "[DB/C]: Exceeded maximum cursors");
		return(-3);
	}


	/* Branch on Command */
	switch (ptr1[0]) {
		case 'C':
			if (!strcmp(ptr1, "CONNECT")) {
				fcmdmatch = 1;
				uid[0] = passwd[0] = server[0] = string[0] = 0;
				strcpy(cnctstr, cmdbuf);
				if (strstr(cnctstr, "=") == NULL) {     /* replace */
					for (index = 0; adr2[index] != 0;) {
						index++;
					}
					if (index == 3) {
						retcode = dbctostr((unsigned char *)adr2[0], server, 50);
						if (!retcode) {
							retcode = dbctostr((unsigned char *)adr2[1], uid, 50);
						}
						if (!retcode) {
							dbctostr((unsigned char *)adr2[2], passwd, 50);
						}
					} else if (index == 2) {
							retcode = dbctostr((unsigned char *)adr2[0], uid, 50);
							if (!retcode) {
								dbctostr((unsigned char *)adr2[1], passwd, 50);
							}
					} else if (index == 1) {
							dbctostr((unsigned char *)adr2[0], uid, 50);
					}
				} else {  /* keywords */
					ptr1 += strcspn(ptr1, " \t");
					if (*ptr1) {  /* name, server, ... */
						ptr1 += strspn(ptr1, " \t");
					}
					while (TRUE) {
						if (*ptr1 == 0) {
							break;
						}
						ptr2 = ptr1 + strcspn(ptr1, "=");
						if (*ptr2 == 0) {
							break;
						}
						*ptr2++ = 0;
						if (!stricmp(ptr1, "NAME")) {
							destptr = uid;
						} else if (!stricmp(ptr1, "PASSWORD")) {
							destptr = passwd;
						} else if (!stricmp(ptr1, "SERVER")) {
							destptr = server;
						} else if (!stricmp(ptr1, "STRING")) {
							destptr = string;
						} else {
							break;
						}
						ptr1 = ptr2 + strcspn(ptr2, ",");   /* value */
						if (*ptr1 != 0) {
							ptr1++;
						}
						ptr3 = ptr2 + strcspn(ptr2, " \t,");
						*ptr3 = 0;
						strncpy(destptr, ptr2, 50);
						if (*ptr1 == 0) {
							break;
						}
						ptr1 += strspn(ptr1, " \t");
						if (*ptr1 == 0) {
							break;
						}
					}
				}
				retcode = dbcconnect(cmdbuf, uid, passwd, server, string);
				if (retcode < 0) {
					connectflag = FALSE;
				} else if (retcode > 0) {
					connectflag = TRUE;
				} else {
					connectflag = TRUE;
				}
				return(retcode);
			} else if (!strcmp(ptr1, "CLOSE")) {
				fcmdmatch = 1;
				if (!connectflag) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Attempt to close when not connected");
					return(-1);
				}
				strcpy(cnctstr, cmdbuf);
				ptr1 = strtok(cnctstr, " \t");
				ptr2 = strtok(NULL, " \t");
				if (ptr1 == NULL && ptr2 == NULL) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Unable to parse close command");
					return(-1);
				}
				cursornum = getcursornum(ptr2);
				if (cursornum < 0) {
					return(0);
				}
				retcode = dbcclose(cmdbuf, cursornum);
				return(retcode);
			} else if (!strcmp(ptr1, "COMMIT")) {
				fcmdmatch = 1;
				if (!connectflag) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Attempt to commit when not connected");
					return(-1);
				}
				retcode = dbcexecdir(cmdbuf);
/*
				retcode = dbccommit();
*/
				return(retcode);
			} else {
				fcmdmatch = 0;
			}
			break;
		case 'D':
			if (!strcmp(ptr1, "DISCONNECT")) {
				fcmdmatch = 1;
				if (!connectflag) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Attempt to disconnect when not connected");
					return(-1);
				}
				retcode = dbcdisconnect();
				connectflag = FALSE;
				return(retcode);
			} else if (!strcmp(ptr1, "DELETE")) {
				fcmdmatch = 1;
				if (!connectflag) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Attempt to delete when not connected");
					return(-1);
				}
				if (foundcursor) {
					strcat(cmdbuf, "OF ");
					strcat(cmdbuf, cursorname);
				}
				retcode = dbcupddel(cmdbuf, foundcursor, cursornum, DBC_DEL);
				return(retcode);
			} else {
				fcmdmatch = 0;
			}
			break;
		case 'F':
			if (!strcmp(ptr1, "FETCH")) {
				fcmdmatch = 1;
				if (!connectflag) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Attempt to fetch when not connected");
					return(-1);
				}
				strcpy(cnctstr, cmdbuf);
				ptr1 = strtok(cnctstr, " \t");
				ptr2 = strtok(NULL, " \t");
				if (ptr1 == NULL || ptr2 == NULL) {
					index = 0;
					fetchtype = DBC_FET_NEXT;
				} else {
					ptr1 = ptr2;
					while (*ptr2) {
						*ptr2 = (char)toupper(*ptr2);
						ptr2++;
					}
					if (!strcmp(ptr1, "FIRST")) {
						index = 0;
						fetchtype = DBC_FET_FIRST;
					} else if (!strcmp(ptr1, "NEXT")) {
						index = 0;
						fetchtype = DBC_FET_NEXT;
					} else if (!strcmp(ptr1, "LAST")) {
						index = 0;
						fetchtype = DBC_FET_LAST;
					} else if (!strcmp(ptr1, "RELATIVE")) {
						fetchtype = DBC_FET_REL;
						ptr1 = strtok(NULL, " \t");
						if (ptr1 == NULL) {
							localerr = TRUE;
							strcpy(errorstr, "[DB/C]: Unable to parse fetch command : 1");
							return(-1);
						}
						if (*ptr1 == '-') {
							ptr1++;
							index = -atoi(ptr1);
						} else {
							index = atoi(ptr1);
						}
						if (index == 0 && *ptr1 != '0') {
							localerr = TRUE;
							strcpy(errorstr, "[DB/C]: Unable to parse fetch command : 2");
							return(-1);
						}
					} else if (!strcmp(ptr1, "ABSOLUTE") || !strcmp(ptr1, "RANDOM")) {
						fetchtype = DBC_FET_ABS;
						ptr1 = strtok(NULL, " \t");
						if (ptr1 == NULL) {
							localerr = TRUE;
							strcpy(errorstr, "[DB/C]: Unable to parse fetch command : 3");
							return(-1);
						}
						if (*ptr1 == '-') {
							ptr1++;
							index = -atoi(ptr1);
						} else {
							index = atoi(ptr1);
						}
						if (index == 0 && *ptr1 != '0') {
							localerr = TRUE;
							strcpy(errorstr, "[DB/C]: Unable to parse fetch command : 4");
							return(-1);
						}
					} else if (!strcmp(ptr1, "PRIOR") || !strcmp(ptr1, "PREV") || !strcmp(ptr1, "PREVIOUS")) {
						index = 0;
						fetchtype = DBC_FET_PREV;
					} else {
						localerr = TRUE;
						strcpy(errorstr, "[DB/C]: Unable to parse fetch command : 5");
						return(-1);
					}
				}
				retcode = dbcfetch(cmdbuf, cursornum, fetchtype, index, (unsigned char **)adr3);
				return(retcode);
			} else {
				fcmdmatch = 0;
			}
			break;
		case 'R':
			if (!strcmp(ptr1, "ROLLBACK")) {
				fcmdmatch = 1;
				if (!connectflag) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Attempt to rollback when not connected");
					return(-1);
				}
				retcode = dbcexecdir(cmdbuf);
/*
				retcode = dbcrollback();
*/
				return(retcode);
			} else {
				fcmdmatch = 0;
			}
			break;
		case 'S':
			if (!strcmp(ptr1, "SELECT")) {
				fcmdmatch = 1;
				if (!connectflag) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Attempt to select when not connected");
					return(-1);
				}
				/* all scroll and lock options are nonzero */
				scroll = 0;
				lock = 0;
				/* First word after SELECT in cnctstr*/
				strcpy(cnctstr, cmdbuf);
				ptr1 = strtok(cnctstr, " \t");
				ptr1 = strtok(NULL, " (\t");
				if (ptr1 == NULL) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Unable to parse select statement : 1");
					return(-1);
				}
				ptr2 = ptr1;
				while (*ptr2) {
					*ptr2 = (char)toupper(*ptr2);
					ptr2++;
				}
				if (!strcmp(ptr1, "OPTIONS")) {
					ptr3 = strstr(cmdbuf, ")");
					if (ptr3 == NULL) {
						localerr = TRUE;
						strcpy(errorstr, "[DB/C]: Unable to parse select statement : 2");
						return(-1);
					}
					optstart = ptr1 - cnctstr;
					optend = ptr3 - cmdbuf;
					ptr1 = strtok(NULL, " ,()=\t"); /* LOCK, SCROLL, ... */
					while (TRUE) {
						if (ptr1 == NULL) {
							localerr = TRUE;
							strcpy(errorstr, "[DB/C]: Unable to parse select statement : 3");
							return(-1);
						}
						ptr2 = ptr1;
						while (*ptr2) {
							*ptr2 = (char)toupper(*ptr2);
							ptr2++;
						}
						if (!strcmp(ptr1, "LOCK")) {
							ptr1 = strtok(NULL, " =,)\t");   /* value */
							if (ptr1 == NULL) {
								localerr = TRUE;
								strcpy(errorstr, "[DB/C]: Unable to parse select statement : 4");
								return(-1);
							}
							ptr2 = ptr1;
							while (*ptr2) {
								*ptr2 = (char)toupper(*ptr2);
								ptr2++;
							}
							if (!strcmp(ptr1, "READONLY")) {
								lock = DBC_CON_RDONLY;
							} else if (!strcmp(ptr1, "OPTBYTIME")) {
								lock = DBC_CON_OPTTIME;
							} else if (!strcmp(ptr1, "OPTBYVAL")) {
								lock = DBC_CON_OPTVAL;
							} else if (!strcmp(ptr1, "FETCH")) {
								lock = DBC_CON_LOCK;
							} else {
								localerr = TRUE;
								strcpy(errorstr, "[DB/C]: Illegal LOCK Option");
								return(-1);
							}
						} else if (!strcmp(ptr1, "SCROLL")) {
							ptr1 = strtok(NULL, " =,)\t");
							if (ptr1 == NULL) {
								localerr = TRUE;
								strcpy(errorstr, "[DB/C]: Unable to parse select statement : 5");
								return(-1);
							}
							ptr2 = ptr1;
							while (*ptr2) {
								*ptr2 = (char)toupper(*ptr2);
								ptr2++;
							}
							if (!strcmp(ptr1, "FORWARD")) {
								scroll = DBC_CUR_FOR;
							} else if (!strcmp(ptr1, "DYNAMIC")) {
								scroll = DBC_CUR_DYN;
							} else if (!strcmp(ptr1, "KEYSET")) {
								scroll = DBC_CUR_KEY;
							} else {
								localerr = TRUE;
								strcpy(errorstr, "[DB/C]: Illegal SCROLL Option");
								return(-1);
							}
						} else {
							break;
						}


						if (lock && scroll) {
							break;
						}
						ptr1 = strtok(NULL, " ,=)\t");

					}
					strncpy(cnctstr, cmdbuf, optstart);
					cnctstr[optstart] = 0;
					strcat(cnctstr, cmdbuf + optend + 1);
					retcode = dbcselect(cnctstr, cursornum, scroll, lock);
				} else {
					retcode = dbcselect(cmdbuf, cursornum, 0, 0);
				}
				return(retcode);
			} else {
				fcmdmatch = 0;
			}
			break;
		case 'U':
			if (!strcmp(ptr1, "UPDATE")) {
				fcmdmatch = 1;
				if (!connectflag) {
					localerr = TRUE;
					strcpy(errorstr, "[DB/C]: Attempt to update when not connected");
					return(-1);
				}
				if (foundcursor) {
					strcat(cmdbuf, "OF ");
					strcat(cmdbuf, cursorname);
				}
				retcode = dbcupddel(cmdbuf, foundcursor, cursornum, DBC_UPD);
				return(retcode);
			} else {
				fcmdmatch = 0;
			}
			break;
		default:
			fcmdmatch = 0;
			break;
	}
	if (!fcmdmatch) {
		if (!connectflag) {
			localerr = TRUE;
			strcpy(errorstr, "[DB/C]: Attempt to execute an SQL statement when not connected");
			return(-1);
		}
		retcode = dbcexecdir(cmdbuf);
	}
	return(retcode);
}


/* DBCSQLM */
char *dbcsqlm(code)
long code;
{
	char *retstr;

	if (localerr) {
		localerr = FALSE;
		return(errorstr);
	} else {
		retstr = dbcgeterr(code);
		strcpy(cmdbuf, retstr);
		return(cmdbuf);
	}
}

void dbcsqlc()
{
#if 0
/*** CODE: IT USE TO BE !connectflag WHICH WAS A BUG.  PROBLEM IS THAT FIXING ***/
/***       IT COULD CAUSE A DISCONNECTION DURING A CHAIN WHICH MAY NOT BE WANTED ***/
	if (connectflag) {
		dbcdisconnect();
		connectflag = FALSE;
	}
#endif

	return;
}
